package src;

public class Ouvrage implements Comparable<Ouvrage> {

	// variables d'instance
	protected String titre, auteur;
	protected boolean emprunte;
	protected int compteur; // nombre d'emprunts

	// methodes et constructeurs
	public Ouvrage(String tit, String aut) {
		this.titre = tit;
		this.auteur = aut;
	}

	public String toString() {
		return "Titre; " + titre + " Auteur; " + auteur + " emprunter: " + emprunte;
	}

	public void emprunter() throws NonDisponibleException {
		if (this.emprunte == true) {
			throw new NonDisponibleException();
		} else {
			this.emprunte = true;
			this.compteur++;
		}
	}

	public void retourner() {
		this.emprunte = false;
	}

	public int getCompteur() {
		return this.compteur;
	}

	@Override
	public int compareTo(Ouvrage ouvrage) {
		if (this.compteur <= ouvrage.compteur) {
			return -1;
		} else {
			return 1;
		}
	}

	public void setTitre(String titre) {
		this.titre = titre;
	}

	public void setAuteur(String auteur) {
		this.auteur = auteur;
	}

	public void setEmprunte(boolean emprunte) {
		this.emprunte = emprunte;
	}

	public void setCompteur(int compteur) {
		this.compteur = compteur;
	}

	public String getTitre() {
		return titre;
	}

	public String getAuteur() {
		return auteur;
	}

	public boolean isEmprunte() {
		return emprunte;
	}
}
