package test;


import static org.junit.Assert.assertTrue;

import org.junit.Before;
import org.junit.Test;
import src.*;

public class RevueTest {

	public Ouvrage o;
	public Revue r1;
	public Revue r2;
	
	@Before
	public void initVals(){
		o = new Ouvrage("test","vinz");
		r1 = new Revue("test2", "vinz", 20180500, 1);
		r2 = new Revue("test2", "vinz", 20180517, 1);
	}
	
	@Test
	public void emprunterValeurEmprunteTest() throws NonDisponibleException{
		assertTrue(r1.isEmprunte()==false);
		r1.emprunter();
		
		assertTrue(r1.isEmprunte()==true);

	}

	@Test
	public void emprunterValeurCompteurTest() throws NonDisponibleException{
		assertTrue(r1.getCompteur()==0);
		r1.emprunter();
		
		assertTrue(r1.getCompteur()==1);

	}
	
	@Test(expected = NonDispoException.class)
	public void emprunterExceptionLanceeTest() throws NonDispoException, NonDisponibleException{
		r2.emprunter(20180518);
		
	}

}
